# OTT mirror
# Copyright (C) 2014-2016 Balthasar Szczepański
# bot2.awk (bothasar_t)
# relinking, archiving avatars, attachments, images.
# 28.03.2016

# This file is part of OTT mirror.
#
# OTT mirror is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affreo General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# OTT mirror is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affreo General Public License for more details.
# 
# You should have received a copy of the GNU Affreo General Public License
# along with OTT mirror. If not, see <http://www.gnu.org/licenses/>.

BEGIN {
#	print download
	related=0
	related2=0
	related3=0
	related4=0
	related5=0
	related6=0
	np=0
	p=0
###USERAGENT2a
	arr[0]=0
	arr2[0]=0
###findpost_path
###imgformat_path
###wayback
###fora
	
	if (wait=="")
	{
		wait=15
	}
	printf("")>outfile
	
	for(i=0;i<256;++i)
	{
		ch=sprintf("%c",i)
		hex=sprintf("%02X",i);
		ch2hex[ch]=hex
	}
	noquot=0;
};
{
	gsub(/href=\"\./, "href=\"" fora, $0)
	gsub(/src=\"\./, "src=\"" fora, $0)
	gsub(/action=\"\./, "action=\"" fora, $0)
	gsub(/(&amp;|\?)sid=................................/, "", $0)
	gsub(/\">/, "\" >", $0)
	gsub(/\" \/>/, "\" />", $0)
	# print $0
	
	for (i=1;i<=NF;++i)
	{
		related=0
		related2=0
		related3=0
		related4=0
		related5=0
		related6=0
		np=0
		p=0
		
		if ($i ~ /^id=.p[0-9]/)
		{
			split($i, arr, "\"p?")
			id=arr[2]
		}
		if ($(i-1) ~ /^class=\"post-buttons\"/ ) #")
		{
			noquot=1
			print ">" >> outfile
		}
		if ($(i) ~ /^<\/ul/)
		{
			noquot=0;
		}
		
		# relink OTT links to mirror links
		if($i ~ /###links_regexp;/)
		{
			split($i, arr, "#|\?|&amp;|\"|\"")
			for(j=1;j in arr;++j)
			{
				split(arr[j], arr2, "=")
				if(arr2[1]=="t")
				{
					if(arr2[2]==###threadID;)
						related=1
					else
					{
						related=0
						break
					}
				}
				else if(arr2[1]=="start")
				{
					np=(arr2[2]/40)+1
				}
				else if(arr2[1]=="p"||arr[j]~/p[0-9]+/)
				{
					if(arr2[1]=="p")
						p=arr2[2]
					else
						p=substr(arr[j],2)
					if((related==0)||(np==0))
					{
						printf("%s %s > %s\n",findpost_path,p,tempfile)|"sh"
						close("sh")
						getline np<tempfile
						close(tempfile)
						if (np!=0)
							related=1
						else
						{
							related=0
							break
						}
					}
				}
			}
		}
		
		# relink prosilver(default) to mirror
		else if($i ~ /###prosilver_regexp;/)
		{
			split($i, arr, "###prosilver_regexp2;")
			related2=1
		}
		
		# relink smileys to mirror
		else if($i ~ /###smiley_regexp;/)
		{
			split($i, arr, "###smiley_regexp2;")
			related5=1
		}
		
		# download and relink avatars
		else if($i ~ /###avatar_regexp;/)
		{
			split($i, arr, "\"")
			split(arr[2],arr2,"=")
			arr2[1]=avatarpath arr2[2]
			if (system("[ -f " arr2[1] " ]")==0)
			{
				related3=1
			}
			else if (tolower(download)=="yes")
			{
				if (system("wget -q -t 3 -U " useragent " -O " tempfile " " arr[2])==0)
				{
					if ((system ("mv " tempfile " " arr2[1]))==0)
					{
						printf ("\nsaved avatar %s", arr2[2])
						related3==1
					}
					else
					{
						printf ("\nCOPY FAIL %s", arr2[2])
					}
						system("sleep " wait)
				}
				else
				{
					printf ("\nDOWNLOAD FAIL %s", arr2[2])
				}
			}
		}
		
		# download and relink attachments
		else if($i ~ /###attachment_regexp;/)
		{
			split($i, arr, "(\")|(%)")
			split(arr[2],arr2,"(\?id=)|((\?mode=view)?&amp;(id=)?)");
			sub(/([^0123456789])+/,"",arr2[2])
			if (arr2[3] ~ /^t/)
			{
				arr2[2] = arr2[2] "_r"
				arr[2] = arr[2] "&t=1"
			}
			arr2[1] = attachmentpath arr2[2]
			
			if (system("[ -f " arr2[1] ".* ]")==0)
			{
				related4=1
			}
			else if (tolower(download2)=="yes")
			{
				r=system ("wget -q -t 3 -S -U " useragent " -O " tempfile " \"" arr[2] "\" 2> " tempfile2)
				d=""
				h404=""
				ext=""
				cdf=""
				ctf=""
				while((getline hline < tempfile2)>0)
				{
					if (tolower(hline) ~ /^ *http/)
					{
						split(hline, arr3, " ")
						if(arr3[2]>=400&&arr3[2]<500)
						{
							printf ("\nHTTP %s %s", arr3[2], arr2[2])
							h404=1
							break
						}
						else if((arr3[2]!=200)||(r!=0))
						{
							printf ("\nHTTP %s %s", arr3[2], arr2[2])
							exit 1
						}
						else
						{
							d=1
						}
					}
					else if(tolower(hline) ~ /^ *content-disposition/)
					{
						split(hline, arr3, " ")
						for(k=1;k in arr3;++k)
						{
							if(arr3[k] ~ /filename/)
							{
								split(arr3[k],arr4,"\.")
								for(l=1;l in arr4;++l)
									ext=("." tolower(arr4[l]))
								cdf=1
							}
						}
					}
					# only if content-disposition fails:
					else if((cdf=="")&&(tolower(hline) ~ /^ *content-type/))
					{
						split(hline, arr3, " ")
						if (arr3[2] ~ /image\/png/)
							ext=".png"
						else if (arr3[2] ~ /image\/jpeg/)
							ext=".jpg"
						else if (arr3[2] ~ /image\/gif/)
							ext=".gif"
						else
						{
							printf ("\nCONTENT %s %s", arr3[2], arr2[2])
							ctf=1
						}
						break
					}
				}
				close (tempfile2)
				if((ctf!="")&&(cdf==""))
				{
					printf("\nCONTENT RECOGNITION FAIL.")
					exit 1
				}
				if ((h404=="")&&(d!=""))
				{
					if ((system ("mv " tempfile " " arr2[1] ext))==0)
					{
						related4=1
						printf ("\nsaved attachment %s%s", arr2[2],ext)
					}
					else
					{
						printf ("\nCOPY FAIL %s", arr2[2])
						exit 1
					}
					system ("sleep " wait)
				}
			}
		}
		
		# download and relink images
		else if(($i ~ /src=.https?:\/\//)&&($(i-1) ~ /<img/) && ($i !~ /###own_image_regexp;/))
		{
			split($i, arr,"\"");
			gsub(/&amp;/,"\&",arr[2]);
			esc=escapename(arr[2])
			esclen = length(esc)
			imgdir = ""
			for(j=0;esclen-j*200>240;++j)
			{
				imgdir = (imgdir substr(esc,1+200*j,200) "/")
			}
			imgname = substr(esc,1+200*j)
			
			if (system("[ -f " imagepath imgdir imgname ".* ]")==0)
			{
				related6=1
				ext=""
			}
			else if (tolower(download3)=="yes")
			{
				ext=""
				r=system ("wget -q --no-check-certificate -t 3 -S -U " useragent " -O " tempfile " \"" arr[2] "\" 2> " tempfile2)
				if(r)
					r=system ("wget -q --no-check-certificate -t 3 -S -U " useragent " -O " tempfile " \"" wayback arr[2] "\" 2> " tempfile2)
				if(r)
					printf("\nfailed to download %s",arr[2])
				else
				{
					r=system(imgformat_path " " tempfile)
					if(r==1)
						ext=".gif"
					else if(r==2)
						ext=".png"
					else if(r==3)
						ext=".jpg"
					else if(r==4)
						ext=".bmp"
					else
					{
						ext=""
						printf("\nfailed to determine format: %s", arr[2])
					}
					if(ext!="")
					{
						if ((system ("mkdir -p " imagepath imgdir))==0)
						{
							if ((system ("mv " tempfile " " imagepath imgdir imgname ext))==0)
							{
								related6=1
								printf ("\nsaved image %s", arr[2])
							}
							else
							{
								printf ("\nCOPY FAIL %s %s",arr[2], imagepath imgdir imgname ext)
							}
						}
						else
						{
							printf ("\nMKDIR FAIL %s %s",arr[2], imagepath imgdir)
						}
					}
					system ("sleep " wait)
				}
			}
		}
		
		# apply the prepared changes
		if (related==1)
		{
			printf("href=\"/ott/view") >> outfile
			if(np>0)
			{
				printf("?np=%s",np) >> outfile
				if(p>0)
				{
					printf("&amp;p=%s#p%s",p,p) >> outfile
				}
			}
			printf("\"")>outfile
		}
		else if (related2==1)
		{
			printf("%s/ott/prosilver%s",arr[1],arr[2]) >> outfile
		}
		else if (related5==1)
		{
			printf("%s/ott/prosilver/smilies%s",arr[1],arr[2]) >> outfile
		}
		else if (related3==1)
		{
			printf("%s\"/ott/avatar/%s\"%s", arr[1],arr2[2],arr[3]) >> outfile
		}
		else if (related4==1)
		{
			printf("%s\"/ott/attachment/%s\"\n",arr[1],arr2[2]) >> outfile
		}
		else if (related6==1)
		{
			printf("%s\"/ott/image/%s\"\n",arr[1],imgdir imgname) >>outfile
		}
		else if(noquot != 0)
		{
		
		}
		else
		{
			printf("%s", $i) >> outfile
		}
		if(i==NF)
			printf("\n") >> outfile
		else
			printf(" ") >> outfile
	}
	
	# add quote button
	if($0 ~ /<div class=.postbody/)
	{
		print "<ul class=\"profile-icons\" >" >> outfile
		print "<li class=\"quote-icon\" ><a title=\"Reply with quote\" href=\"###foraaddr;/posting.php?mode=quote&amp;f=7&amp;p=" id "\" ></a></li>" >> outfile
		print "<li class=\"quote-icon-mustard\" ><a title=\"Reply with quote\" href=\"/ott/post?q=p" id "\" ></a></li>" >> outfile
		print "</ul>" >> outfile
	}
};
#END {
#	exit related
#}
function escapename(name)
{
	len=length(name)
	escaped=""
	for(iii=1;iii<=len;++iii)
	{
		ch=substr(name,iii,1);
		if (ch ~ /[a-z]|[A-Z]|[0-9]/)
			escaped = escaped ch
		else
			escaped = escaped "_" ch2hex[ch]
	}
	return escaped
};