# OTT mirror
# Copyright (C) 2014, 2016 Balthasar Szczepaski
# findlatest.awk 
# find the latest page and number of posts.
# 28.03.2016

# This file is part of OTT mirror.
#
# OTT mirror is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affreo General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# OTT mirror is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affreo General Public License for more details.
# 
# You should have received a copy of the GNU Affreo General Public License
# along with OTT mirror. If not, see <http://www.gnu.org/licenses/>.

BEGIN {
	a=1;
};
{
	if (posts== "")
	{
		for(i=1;i<=NF;i++)
		{
			if(tolower($i) ~ /posts/ && $(i-1) ~ /^[0-9]+$/)
				posts=$(i-1)
		}
	}
	else 	if (tolower($0) ~ /page/)
	{
		gsub(/<[^>]*>/," ",$0)
		for(i=1;i<=NF;i++)
		{
			if((tolower($i) ~ /page/) && (tolower($(i+2)) ~ /of/))
			{
				print $(i+3) >outfile
				print posts  >> outfile
				a=0;
				exit a;
			}
		}
	}
};
END {
	exit a
}
