# OTT mirror
# Copyright (C) 2014, 2016 Balthasar Szczepański
# index.awk
# separate the topic from index page.
# 31.03.2016

# This file is part of OTT mirror.
#
# OTT mirror is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affreo General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# OTT mirror is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affreo General Public License for more details.
# 
# You should have received a copy of the GNU Affreo General Public License
# along with OTT mirror. If not, see <http://www.gnu.org/licenses/>.

BEGIN{
	related=1
#1=no 0=yes
	where=0
	printf("%s","") > outfile 
};
{
	if((related!=0)&& ($0 ~ /<li class=.row/))
	{
		where=1
		level=0;
		printf("%s","") > outfile
	}
	else if ($0 ~ /<li/ && where==1)
		++level
	
	if ($0 ~ /t=###threadID;/)
	{
		related=0
	}
	
	if(where==1)
	{
		print $0 >> outfile
	}
	
	if($0 ~ /<\/li>/)
	{
		if(level>0)
			--level
		else
		{
			where=0
			close(outfile)
		}
	}
};
END{
	exit related
}