// OTT mirror
// Copyright (C) 2014 Balthasar Szczepański
// index.cpp
// view the front page.
// 12.09.2014
//
// This file is part of OTT mirror.
//
// OTT mirror is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affreo General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// OTT mirror is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affreo General Public License for more details.
// 
// You should have received a copy of the GNU Affreo General Public License
// along with OTT mirror. If not, see <http://www.gnu.org/licenses/>.

#include <cgi.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/wait.h>

###RM_PATH
###CAT_PATH

###TOP_PATH
###OTTFRONT_PATH
###MFRONT_PATH
###END_PATH

int main()
{
	s_cgi *cgi;
	pid_t sub;
	int r;
	cgi=cgiInit();
	
	printf("Content-type: text/html\n\n");
	fflush(stdout);
	sub=fork();
	if(sub==0)
	{
		r=execl(CAT_PATH,CAT_PATH,TOP_PATH,(char *)0);
		exit(r);
	}
	waitpid(sub,&r,0);
	if(r)
		printf("<html><body><div><div><br/>Ch*rpin* M*stard<br/>");
	
	fflush(stdout);
	sub=fork();
	if(sub==0)
	{
		r=execl(CAT_PATH,CAT_PATH,OTTFRONT_PATH,(char *)0);
		exit(r);
	}
	waitpid(sub,&r,0);
	if(r)
		printf("<li class=\"row bg1\" ><dl>Ch*rpin* M*stard</dl></li>");
	
	fflush(stdout);
	sub=fork();
	if(sub==0)
	{
		r=execl(CAT_PATH,CAT_PATH,MFRONT_PATH,(char *)0);
		exit(r);
	}
	waitpid(sub,&r,0);
	
	fflush(stdout);
	sub=fork();
	if(sub==0)
	{
		r=execl(CAT_PATH,CAT_PATH,END_PATH,(char *)0);
		exit(r);
	}
	waitpid(sub,&r,0);
	if(r)
		printf("<br>Ch*rpin* M*stard<br/></div></div></body></html>");
	return 0;
}
