// OTT mirror
// Copyright (C) 2014 Balthasar Szczepański
// update.cpp
// update a page.
// 12.09.2014
//
// This file is part of OTT mirror.
//
// OTT mirror is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affreo General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// OTT mirror is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affreo General Public License for more details.
// 
// You should have received a copy of the GNU Affreo General Public License
// along with OTT mirror. If not, see <http://www.gnu.org/licenses/>.

#include <cgi.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/wait.h>

###BOT_PATH
#define UPDATE_PATH "/ott/update.htm"

int main()
{
	s_cgi *cgi;
	pid_t sub;
	int r;
	
	char *arg;
	
	cgi=cgiInit();
	arg=cgiGetValue(cgi,"np");
	if(arg!=NULL)
	{
		printf("Content-type: text\n\n");
		fflush(stdout);
		dup2(fileno(stdout),fileno(stderr));
		sub=fork();
		if(sub==0)
		{
			printf("%s\n",BOT_PATH);
			r=execl(BOT_PATH,BOT_PATH,"-i","4","-s",arg,"-m","1","-w","15","-v","15","-d","-a","-b","-t",(char *)0);
			printf("AAA\n");
			exit(r);
		}
		waitpid(sub,&r,0);
		printf("%x\n",r);
	}
	else
	{
		cgiRedirect(UPDATE_PATH);
	}
	return 0;
}
